 ;This is a program to draw a wide-flange column with a base plate.
;Written by the MSU-B-COT (formerly Billings Vo-Tech) Programming
;for CAD Applications class on 2-6-95. 
;
(Defun C:colwbpl ()
 (setvar "cmdecho" 0) 
 (textscr)
  (setq cwd (getdist  "\nColumn Web Depth: "))
  (setq cfw (getdist  "\nColumn Flange Width: "))
  (setq ft  (getdist  "\nColumn Flange Thickness: "))
  (setq oh  (getdist  "\nOverall Column Height: "))
  (setq bpt (getdist  "\nBase Plate Thickness: "))
  (setq bph (getdist  "\nBase Plate Horizontal: "))
  (setq bpv (getdist  "\nBase Plate Vertical: "))
  (setq hsh (getdist  "\nHole Spacing Horizontal: "))
  (setq hsv (getdist  "\nHole Spacing Vertical: "))
  (setq hd  (getdist  "\nHole Diameter: "))
 (graphscr)
  (setq sp  (getpoint "\nSelect The Bottom Center of the Base Plate: "))
  (setq cl  (getvar "clayer"))
;End of info gathering sequence - start of polar point setting
  (setq tp  (polar sp (dtr 90) oh))
  (setq tpl2 (polar tp (dtr 180) (/ cwd 2.0)))
  (setq tpl1 (polar tpl2 (dtr 0.0) ft))
  (setq tpr2 (polar tp (dtr 0.0) (/ cwd 2.0)))
  (setq tpr1 (polar tpr2 (dtr 180) ft))
  (setq stl  (- oh bpt)) ;overall steel length    
  (setq lpl2 (polar tpl2 (dtr 270) stl))
  (setq lpl1 (polar tpl1 (dtr 270) stl))
  (setq rpl2 (polar tpr2 (dtr 270) stl))
  (setq rpl1 (polar tpr1 (dtr 270) stl))
    (command "layer" "m" "column" "c" "yellow" "" "")
    (command "line" lpl2 tpl2 tpr2 rpl2 "")
    (command "line" tpl1 lpl1 "")
    (command "line" rpl1 tpr1 "")
;End of column vertical drawing sequence
  (setq bpl1 (polar sp (dtr 180) (* 0.5 bph)))
  (setq bpl4 (polar sp (dtr 0.0) (* 0.5 bph)))
  (setq bpl2 (polar bpl1 (dtr 90) bpt))
  (setq bpl3 (polar bpl4 (dtr 90) bpt))
  (setq hml  (polar sp (dtr 180) (* 0.5 hsh)))
    (setq hmlll (polar hml (dtr 180) (* 0.5 hd)))
    (setq hmllr (polar hml (dtr 0.0) (* 0.5 hd)))
    (setq hmlul (polar hmlll (dtr 90) bpt))
    (setq hmlur (polar hmllr (dtr 90) bpt))
  (setq hmr  (polar sp (dtr 0.0) (* 0.5 hsh)))
  (setq hmr  (polar sp (dtr 0) (* 0.5 hsh)))
    (setq hmrll (polar hmr (dtr 180) (* 0.5 hd)))
    (setq hmrlr (polar hmr (dtr 0.0) (* 0.5 hd)))
    (setq hmrul (polar hmrll (dtr 90) bpt))
    (setq hmrur (polar hmrlr (dtr 90) bpt))
  (setq hmr  (polar sp (dtr 0.0) (* 0.5 hsh)))
    (command "line" bpl1 bpl2 bpl3 bpl4 "c")
    (command "layer" "make" "holes" "c" "red" "" "")
    (command "solid" hmlll hmllr hmlul hmlur "")
    (command "solid" hmrll hmrlr hmrul hmrur "")
;End of base plate edge view drawing sequence
  (setq bp1 (polar bpl1 (dtr 270) bph))
  (setq bp2 (polar bp1  (dtr 0) bph))
  (setq bp3 (polar bp2  (dtr 270) bpv))
  (setq bp4 (polar bp3  (dtr 180) bph))
  (setq bp1h (polar bp1 (dtr 0) (* 0.5 (- bph hsh))))
  (setq bp1h (polar bp1h (dtr 270) (* 0.5 (- bpv hsv))))
  (setq bp2h (polar bp1h (dtr 0) hsh))
  (setq bp3h (polar bp2h (dtr 270) hsv))
  (setq bp4h (polar bp3h (dtr 180) hsh))
    (command "layer" "set" "column" "") 
    (command "line" bp1 bp2 bp3 bp4 "c")
    (command "layer" "set" "holes" "")
    (command "donut" "0.0" hd bp1h bp2h bp3h bp4h "") 
  (setq cp1 (polar lpl2 (dtr 270) (+ bpt bph (* 0.5 (- bpv cfw)))))
  (setq cp2 (polar cp1 (dtr 270) cfw))
  (setq cp3 (polar cp2 (dtr 0) cwd))
  (setq cp4 (polar cp1 (dtr 0) cwd))
  (setq cp5 (polar cp1 (dtr 270) (* 0.5 cfw)))
  (setq cp6 (polar cp5 (dtr 0) cwd))
    (command "layer" "make" "hidden" "lt" "hidden" "" "c" "yellow" "" "")
    (command "line" cp1 cp2 "")
    (command "line" cp3 cp4 "")
    (command "line" cp5 cp6 "") 
;End of base plate in plan sequence - start of dimensioning sequence
  (setq vd1 (polar bpl4 (dtr 0) bph))
  (setq vd2 (polar vd1  (dtr 0) bph))
    (command "layer" "make" "dim" "c" "red" "" "")
    (command "dim1" "vert" bpl3 bpl4 vd1 "") ;overall column dim
    (command "dim1" "vert" vd1 tpr2 vd2 "")  ;base plate thickness dim
  (setq vd3 (polar bp2 (dtr 0) (* 0.5 bph)))
  (setq vd4 (polar vd3 (dtr 0) (* 0.5 bph)))
    (command "dim1" "vert" bp1h bp2 vd3 "")  ;basepl plan upper vertical
    (command "dim1" "vert" bp4h bp3 vd3 "")  ;basepl plan lower vertical
    (command "dim1" "vert" bp3h bp2h vd3 "") ;basepl plan mid vertical
    (command "dim1" "vert" bp3 bp2 vd4 "")   ;basepl plan overall vertical
  (setq hd1 (polar bp4 (dtr 270) (* 0.5 bph)))
    (command "dim1" "hor" bp4 bp3 hd1 "")    ;basepl plan overall horizontal
  (setq hmlu (polar hml (dtr 90) (* bpt 2.0)))
  (setq hmru (polar hmr (dtr 90) (* bpt 2.0)))
  (setq vd5 (polar bp1 (dtr 90) (* bph 0.5)))
    (command "dim1" "hor" bp4h bp1 vd5 "")   ;basepl plan left horiz
    (command "line" hmlu bp1h "")
    (command "dim1" "hor" bp3h bp2 vd5 "")   ;basepl plan right horiz
    (command "line" hmru bp2h "")  
    (command "dim1" "hor" hmlu hmru vd5 "")  ;basepl plan horiz sub
(setvar "clayer" cl)
)
(defun dtr (a) (* pi (/ a 180.0)))
(princ "\nCOLWBPL creates a wide flange column with a base plate ")
(princ)